410. Split Array Largest Sum

Given an array which consists of non-negative integers and an integer m, you can split the array into m non-empty continuous subarrays. Write an algorithm to minimize the largest sum among these m subarrays.

Note:
Given m satisfies the following constraint: 1 ≤ m ≤ length(nums) ≤ 14,000.

Examples:

Input:
nums = [7,2,5,10,8]
m = 2

Output:
18

Explanation:
There are four ways to split nums into two subarrays.
The best way is to split it into [7,2,5] and [10,8],
where the largest sum among the two subarrays is only 18.


dp[i][j]表示nums数组从index=0到index=i,切j刀最小的和,dp[i][j]=min(max(dp[i][k],sums[i]-sums[k])),其中j-1<=k<=i-1,

然而二维数组开不下。

public class Solution {
    public static int splitArray(int[] nums, int m)
	{
		int len=nums.length;
		int[] sums=new int[len];
		int sum=0;
		for(int i=0;i<len;i++)
		{
			sum+=nums[i];
			sums[i]=sum;
		}
		
		int[][] dp=new int[len][len];
		for(int i=0;i<len;i++)
			dp[i][0]=sums[i];
				
		for(int i=0;i<len;i++)
			for(int j=1;j<len;j++)
			{
				if(j>i)
					continue;
				int min=Integer.MAX_VALUE;
				for(int k=i-1;k>=j-1;k--)
					min=Math.min(min, Math.max(dp[k][j-1], sums[i]-sums[k]));
				dp[i][j]=min;
			}
		
		return dp[len-1][m-1];
	}
}


----------------------------------------------------------------------

二分搜索法,摘自

https://discuss.leetcode.com/topic/61324/clear-explanation-8ms-binary-search-java/9


  1. The answer is between maximum value of input array numbers and sum of those numbers.
  2. Use binary search to approach the correct answer. We have l = max number of array; r = sum of all numbers in the array;Every time we do mid = (l + r) / 2;
  3. Use greedy to narrow down left and right boundaries in binary search.
    3.1 Cut the array from left.
    3.2 Try our best to make sure that the sum of numbers between each two cuts (inclusive) is large enough but still less thanmid.
    3.3 We'll end up with two results: either we can divide the array into more than m subarrays or we cannot.
    If we can, it means that the mid value we pick is too small because we've already tried our best to make sure each part holds as many non-negative numbers as we can but we still have numbers left. So, it is impossible to cut the array into m parts and make sure each parts is no larger than mid. We should increase m. This leads to l = mid + 1;
    If we can't, it is either we successfully divide the array into m parts and the sum of each part is less than mid, or we used up all numbers before we reach m. Both of them mean that we should lower mid because we need to find the minimum one. This leads to r = mid - 1;
public class Solution {
    public int splitArray(int[] nums, int m) {
        int max = 0; long sum = 0;
        for (int num : nums) {
            max = Math.max(num, max);
            sum += num;
        }
        if (m == 1) return (int)sum;
        //binary search
        long l = max; long r = sum;
        while (l <= r) {
            long mid = (l + r)/ 2;
            if (valid(mid, nums, m)) {
                r = mid - 1;
            } else {
                l = mid + 1;
            }
        }
        return (int)l;
    }
    public boolean valid(long target, int[] nums, int m) {
        int count = 1;
        long total = 0;
        for(int num : nums) {
            total += num;
            if (total > target) {
                total = num;
                count++;
                if (count > m) {
                    return false;
                }
            }
        }
        return true;
    }
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值